//
//
//
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
//#include <g++/Integer.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#include <errno.h>

#include "xvmsupport.h"
#include "xvm.h"
#include "xvmconfig.h"

#define XVM_VER_SUPPORT "0.1.12"

Xvm *___XXXVMashine;
FILE *___File;

int ___MessageLen=sizeof(struct xvmqueue)-sizeof(long);
int ___Mode;
xvmqueue ___MBuf;
int ___MQueueId;
int ___QueueStatus;
 
int __SaveXVMOptions();
int __SaveXVMCommands();
int __SaveXVMRegisters();
int __LoadXVMOptions();
int __LoadXVMCommands();
int __LoadXVMRegisters();
int __ClearCommands();
int __ClearRegisters();

int 
PrepareSave(char* filename,int mode,Xvm *Mash){
	mode=0;
	___XXXVMashine=Mash;
	if((___File=fopen(filename,"w"))==NULL){
		return -1;
	}
	else{
		return 0;
	};	
};

int 
SaveXVMStatus(){
	__SaveXVMOptions();
	__SaveXVMCommands();
	__SaveXVMRegisters();
	fclose(___File);
	return 1;
};

int 
__SaveXVMOptions(){
	char bufs[MAX_XVM_COMMENT_LEN];
	char *temps=bufs;
	fputs("Start Options\r\n",___File);
	fputs("Ver=",___File);
	strcpy(temps,___XXXVMashine->GetVersion());
	fputs(temps,___File);
	fputs("\r\nEnd Options\r\n",___File);
	return 1;
};

int 
__SaveXVMCommands(){
	char bufs[MAX_XVM_COMM_LEN];
	char *temps=bufs;
	int len;
	int temp;
	len=___XXXVMashine->GetCommListLen();
	fputs("Start Commands\r\n",___File);
	for(temp=1;temp<=len;temp++){
		strcpy(temps,___XXXVMashine->GetComm(temp));
		if(strcmp(temps,"")!=0){
			fputs(" ",___File);
			fputs(ItoA(temp),___File);
			fputs(" \t",___File);
			fputs(temps,___File);
			fputs(" \t",___File);
			strcpy(temps,___XXXVMashine->GetComment(temp));
			fputs(temps,___File);
			fputs("\r\n",___File);
		};
	};
	fputs("End Commands\r\n",___File);
	return 1;
};

int 
__SaveXVMRegisters(){
	char bufs[MAX_XVM_REG_LEN];
	char *temps=bufs;
	int len;
	int temp;
	len=___XXXVMashine->GetRegListLen();
	___XXXVMashine->SyncRegs();
	fputs("Start Registers\r\n",___File);
	for(temp=1;temp<=len;temp++){
		strcpy(temps,___XXXVMashine->GetReg(temp));
		if((*temps!='\0') && (*temps!='0')){
			fputs(" ",___File);
			fputs(ItoA(temp),___File);
			fputs(" \t",___File);
			fputs(temps,___File);
			fputs("\r\n",___File);
		};
	};
	fputs("End Registers\r\n",___File);
	return 1;
};

int 
PrepareLoad(char* filename,int mode,Xvm *Mash){
	mode=0;
	___XXXVMashine=Mash;
	if((___File=fopen(filename,"r"))==NULL){
		return -1;
	}
	else{
		return 0;
	};	
};

int 
LoadXVMStatus(){
	char buf[MAX_XVM_COMMENT_LEN];
	char* temps=buf;
	__ClearCommands();
	__ClearRegisters();
	while(feof(___File)==0){
		if((temps=fgets(temps,MAX_XVM_COMMENT_LEN,___File))!=NULL){
			if(strcmp(temps,"Start Options\r\n")==0)
				__LoadXVMOptions();
			if(strcmp(temps,"Start Commands\r\n")==0)
				__LoadXVMCommands();
			if(strcmp(temps,"Start Registers\r\n")==0)
				__LoadXVMRegisters();
		};
	};
	fclose(___File);
	return 1;
};

int 
__ClearRegisters(){
	int len;
	int temp;
	len=___XXXVMashine->GetRegListLen();
	for(temp=1;temp<=len;temp++){
		___XXXVMashine->SetReg(temp,"0");
		___XXXVMashine->SetNCDReg(temp,0);
	};
	return 1;
};

int 
__ClearCommands(){
	int len;
	int temp;
	len=___XXXVMashine->GetCommListLen();
	for(temp=1;temp<=len;temp++){
		___XXXVMashine->SetComm(temp,"");
		___XXXVMashine->SetComment(temp,"");
	};
	return 1;
};

int 
__LoadXVMOptions(){
	char buf[MAX_XVM_COMMENT_LEN];
	char *temps=buf;
	strcpy(temps,"");
	while(strcmp(temps,"End Options\r\n")!=0 && feof(___File)==0){
		temps=fgets(temps,MAX_XVM_COMMENT_LEN,___File);
	};
	return 1;
};

int 
__LoadXVMCommands(){
	char buf[MAX_XVM_COMM_LEN+MAX_XVM_COMMENT_LEN];
	char *temps=buf;
	char *stok[3];
	temps=fgets(temps,MAX_XVM_COMM_LEN+MAX_XVM_COMMENT_LEN,___File);
	while(strcmp(temps,"End Commands\r\n")!=0 && feof(___File)==0){
		stok[0]=strtok(temps," \t");
		stok[1]=strtok(NULL," \t");
		stok[2]=strtok(NULL,"\t\r\n");
		if(stok[1]!=NULL)
			___XXXVMashine->SetComm(atoi(stok[0]),stok[1]);
		if(stok[2]!=NULL)
			___XXXVMashine->SetComment(atoi(stok[0]),stok[2]);
		temps=fgets(temps,MAX_XVM_COMM_LEN+MAX_XVM_COMMENT_LEN,___File);
	};
	return 1;
};

int 
__LoadXVMRegisters(){
	char buf[MAX_XVM_REG_LEN];
	char *temps=buf;
	char *stok[3];
	temps=fgets(temps,MAX_XVM_REG_LEN,___File);
	while(strcmp(temps,"End Registers\r\n")!=0 && feof(___File)==0){
		stok[0]=strtok(temps," \t");
		stok[1]=strtok(NULL," \t\r\n");
		stok[2]=strtok(NULL,"\t");
		if(stok[1]!=NULL){
			___XXXVMashine->SetReg(atoi(stok[0]),stok[1]);
			___XXXVMashine->SetNCDReg(atoi(stok[0]),atol(stok[1]));
		};
		temps=fgets(temps,MAX_XVM_REG_LEN,___File);
	};
	return 1;
};

int 
InitQueue(){
	key_t key;
	if((key=ftok(XQ_KEY_DIR,XQ_KEY_PRJ))==-1){
		___QueueStatus=XQ_OFF;
		return -1;
	}
	else{
		if((___MQueueId=msgget(key,IPC_CREAT | 0660))==-1){
			___QueueStatus=XQ_OFF;
			return -1;
		}
		else{
			DeleteQueue();
			if((___MQueueId=msgget(key,IPC_CREAT | 0660))==-1){
				___QueueStatus=XQ_OFF;
				return -1;
			}
			else{
				___QueueStatus=XQ_ON;
				___Mode=XQ_T_FROM_S;
				return 1;
			};
		};
	};
};

int 
DeleteQueue(){
	msgctl(___MQueueId,IPC_RMID,0);
	___QueueStatus=XQ_OFF;
	return 1;
};

int 
ConnectQueue(){
	key_t key;
	if((key=ftok(XQ_KEY_DIR,XQ_KEY_PRJ))==-1){
		___QueueStatus=XQ_OFF;
		return -1;
	}
	else{
		if((___MQueueId=msgget(key,IPC_EXCL | 0660))==-1){
			___QueueStatus=XQ_OFF;
			return -1;           
		}
		else{
			___QueueStatus=XQ_ON;
			___Mode=XQ_T_TO_S;
			return 1;
		};
	};
};

int 
SendMessage(int subtype,char *text,int no=1,int res=0){
	char *tempstr;
	tempstr=___MBuf.mtext;
	___MBuf.msubtype=subtype;
	strcpy(tempstr,text);
	___MBuf.mno=no;
	___MBuf.mres=res;
	if(___Mode==XQ_T_FROM_S){
		___MBuf.mtype=XQ_T_FROM_S;
	}
	else{
		___MBuf.mtype=XQ_T_TO_S;
	};
	if(msgsnd(___MQueueId,(struct msgbuf *)&___MBuf,___MessageLen,0)==-1){
		___QueueStatus=XQ_OFF;
		return -1;
	};
	return 1;
};

int 
SendMessage(int subtype){
	___MBuf.msubtype=subtype;
	if(___Mode==XQ_T_FROM_S){
		___MBuf.mtype=XQ_T_FROM_S;
	}
	else{
		___MBuf.mtype=XQ_T_TO_S;
	};
	if(msgsnd(___MQueueId,(struct msgbuf *)&___MBuf,___MessageLen,0)==-1){
		___QueueStatus=XQ_OFF;
		return -1;
	};
	return 1;
};

int 
SendMessage(int subtype,char text,int no=1,int res=0){
	___MBuf.mtext[0]=text;
	___MBuf.msubtype=subtype;
	___MBuf.mno=no;
	___MBuf.mres=res;
	if(___Mode==XQ_T_FROM_S){
		___MBuf.mtype=XQ_T_FROM_S;
	}
	else{
		___MBuf.mtype=XQ_T_TO_S;
	};
	if(msgsnd(___MQueueId,(struct msgbuf *)&___MBuf,___MessageLen,0)==-1){
		___QueueStatus=XQ_OFF;
		return -1;
	};
	return 1;
};

int 
SendMessage(xvmqueue *message){
	if(___Mode==XQ_T_FROM_S){
		message->mtype=XQ_T_FROM_S;
	}
	else{
		message->mtype=XQ_T_TO_S;
	};
	if(msgsnd(___MQueueId,(struct msgbuf *)message,___MessageLen,0)==-1){
		___QueueStatus=XQ_OFF;
		return -1;
	};
	return 1;
};

int 
ReadMessage(char *text,int *subtype=NULL,long *no=NULL){
	int result;
	long mod;
	if(___Mode==XQ_T_FROM_S){
		mod=XQ_T_TO_S;
	}
	else{
		mod=XQ_T_FROM_S;
	};
	if((result=msgrcv(___MQueueId,(struct msgbuf *)&___MBuf,___MessageLen,mod,IPC_NOWAIT))==-1){
		if(errno==ENOMSG){
			return 0;
		}
		else{
			return -1;
			___QueueStatus=XQ_OFF;
		};
	}
	else{
		strcpy(text,___MBuf.mtext);
		if(subtype!=NULL)
			*subtype=___MBuf.msubtype;
		if(no!=NULL)
			*no=___MBuf.mno;
		return 1;
	};
};

int 
ReadMessage(xvmqueue *message){
	int result;
	long mod;
	if(___Mode==XQ_T_FROM_S){
		mod=XQ_T_TO_S;
	}
	else{
		mod=XQ_T_FROM_S;
	};
	if((result=msgrcv(___MQueueId,(struct msgbuf *)message,___MessageLen,mod,IPC_NOWAIT))==-1){
		if(errno==ENOMSG){
			return 0;
		}
		else{
			___QueueStatus=XQ_OFF;
			return -1;
		};
	}
	else{
		return 1;
	};
};

int 
WaitMessage(xvmqueue *message){
	int result;
	long mod;
	if(___Mode==XQ_T_FROM_S){
		mod=XQ_T_TO_S;
	}
	else{
		mod=XQ_T_FROM_S;
	};
	if((result=msgrcv(___MQueueId,(struct msgbuf *)message,___MessageLen,mod,0))==-1){
		/*___QueueStatus=XQ_OFF;*/
		return 0;
	}
	else{
		return 1;
	};
};

int 
GetQueueStatus(){
	return ___QueueStatus;
};

char* 
GetAboutSupport(){
	static char temp[MAX_XQ_MTEXT_LEN];
	strcpy(temp,"Support Lib, ver: ");
	strcat(temp,GetVersionSupport());
	strcat(temp," . Copyright(c) 1998, 1999 Dmitry Morozhnikov.\n");
	return temp;
};

char* 
GetVersionSupport(){
	return XVM_VER_SUPPORT;
};

