//
//
//

#include "xvm.h"

#ifndef XVM_SUPPORT_LIB_H
#define XVM_SUPPORT_LIB_H

char* GetAboutSupport();
char* GetVersionSupport();

#endif //XVM_SUPPORT_LIB_H

#ifndef XVM_SUPPORT_H
#define XVM_SUPPORT_H
int PrepareSave(char* filename,int mode,Xvm *Mash);
int SaveXVMStatus();
int PrepareLoad(char* filename,int mode,Xvm *Mash);
int LoadXVMStatus();
#endif //XVM_SUPPORT_H

#ifndef XVMQUEUE_H
#define XVMQUEUE_H

#define MAX_XQ_MTEXT_LEN 256

struct xvmqueue{
	long mtype;
	int msubtype;
	int mno;
	char mtext[MAX_XQ_MTEXT_LEN];
	int mres;
};

int InitQueue();
int ConnectQueue();
int DeleteQueue();
int GetQueueStatus();
int SendMessage(int subtype,char *text,int no=1,int res=0);
int SendMessage(int subtype,char text,int no=1,int res=0);
int SendMessage(int subtype);
int SendMessage(xvmqueue *message);
int ReadMessage(char *text,int *subtype=NULL,long *no=NULL);
int ReadMessage(xvmqueue *message);
int WaitMessage(xvmqueue *message);

#define XQ_ON 1
#define XQ_OFF -1

#define XQ_T_FROM_S 1
#define XQ_T_TO_S 2

#define XQ_ST_NOP 0
#define XQ_ST_COM 1
#define XQ_ST_INF 2
#define XQ_ST_SET_REG 3
#define XQ_ST_SET_COMM 4
#define XQ_ST_SET_COMMENT 7
#define XQ_ST_GET_REG 5
#define XQ_ST_GET_COMM 6
#define XQ_ST_GET_COMMENT 8
#define XQ_ST_LOAD 9
#define XQ_ST_SAVE 10
#define XQ_ST_GET_ERROR 11
#define XQ_ST_GET_CURCOMMNO 12
#define XQ_ST_GET_PREVCOMMNO 13
#define XQ_ST_GET_PROGSTATUS 14
#define XQ_ST_GET_SERVERSTATUS 15
#define XQ_ST_GET_XVMABOUT 16
#define XQ_ST_GET_XVMVER 17
#define XQ_ST_GET_SUPPORTABOUT 18
#define XQ_ST_GET_SUPPORTVER 19
#define XQ_ST_GET_SERVERABOUT 20
#define XQ_ST_GET_SERVERVER 21
#define XQ_ST_NODELAY 22
#define XQ_ST_DELAY 23
#define XQ_ST_GET_REGLIST 24
#define XQ_ST_GET_COMMLIST 25
#define XQ_ST_GET_COMMENTLIST 26
#define XQ_ST_BUSY 27
#define XQ_ST_NOBUSY 28

#define XQ_TCOM_INIT 'i'
#define XQ_TCOM_STEP 's'
#define XQ_TCOM_EXEC 'e'
#define XQ_TCOM_BREAK 'b'
#define XQ_TCOM_QUIT 'q'

#define XQ_KEY_DIR "."
#define XQ_KEY_PRJ 'x'

#endif //XVMQUEUE_H	
